/***************************************************************************

    mame.c

    Specific (per target) constants

    Copyright Nicola Salmoria and the MAME Team.
    Visit http://mamedev.org for licensing and usage restrictions.

****************************************************************************/

#include "emu.h"

#ifdef ATMAME32KPP
#define APPNAME					"atMAME32kpp"
#define APPNAME_LOWER			"atMAME32kpp"
#define CONFIGNAME				"mame"
#define APPLONGNAME				"at.M.A.M.E.32.kpp"
#define FULLLONGNAME			"A Translated Multiple Arcade Machine Emulator 32 Kaillera Plus Plus"
#define COPYRIGHT				_("Copyright Nicola Salmoria and the MAME team\nhttp://mamedev.org\nUn official Version by Gemuno@Masatti")
#define COPYRIGHT_INFO			_("Copyright Nicola Salmoria and the MAME team and Un official Version by Gemuno@Masatti")
#else
#define APPNAME					"MAME"
#define APPNAME_LOWER			"mame"
#define CONFIGNAME				"mame"
#define APPLONGNAME				"M.A.M.E."
#define FULLLONGNAME			_("Multiple Arcade Machine Emulator")
#define COPYRIGHT				_("Copyright Nicola Salmoria\nand the MAME team\nhttp://mamedev.org")
#define COPYRIGHT_INFO			_("Copyright Nicola Salmoria and the MAME team")
#endif
#define CAPGAMENOUN				_("GAME")
#define CAPSTARTGAMENOUN		_("Game")
#define GAMENOUN				_("game")
#define GAMESNOUN				_("games")
#define DISCLAIMER				_("MAME is an emulator: it reproduces, more or less faithfully, the behaviour of\n" \
								"several arcade machines. But hardware is useless without software, so an image\n" \
								"of the ROMs which run on that hardware is required. Such ROMs, like any other\n" \
								"commercial software, are copyrighted material and it is therefore illegal to\n" \
								"use them if you don't own the original arcade machine. Needless to say, ROMs\n" \
								"are not distributed together with MAME. Distribution of MAME together with ROM\n" \
								"images is a violation of copyright law and should be promptly reported to the\n" \
								"authors so that appropriate legal action can be taken.\n")
#define USAGE					_("Usage:  %s [%s] [options]")
#define XML_ROOT			    "mame"
#define XML_TOP 				"game"
#define STATE_MAGIC_NUM			"MAMESAVE"

const char * emulator_info::get_appname() { return APPNAME;}
const char * emulator_info::get_appname_lower() { return APPNAME_LOWER;}
const char * emulator_info::get_configname() { return CONFIGNAME;}
const char * emulator_info::get_applongname() { return APPLONGNAME;}
const char * emulator_info::get_fulllongname() { return FULLLONGNAME;}
const char * emulator_info::get_capgamenoun() { return CAPGAMENOUN;}
const char * emulator_info::get_capstartgamenoun() { return CAPSTARTGAMENOUN;}
const char * emulator_info::get_gamenoun() { return GAMENOUN;}
const char * emulator_info::get_gamesnoun() { return GAMESNOUN;}
const char * emulator_info::get_copyright() { return COPYRIGHT;}
const char * emulator_info::get_copyright_info() { return COPYRIGHT_INFO;}
const char * emulator_info::get_disclaimer() { return DISCLAIMER;}
const char * emulator_info::get_usage() { return USAGE;}
const char * emulator_info::get_xml_root() { return XML_ROOT;}
const char * emulator_info::get_xml_top() { return XML_TOP;}
const char * emulator_info::get_state_magic_num() { return STATE_MAGIC_NUM;}
void emulator_info::printf_usage(const char *par1, const char *par2) { mame_printf_info(USAGE, par1, par2); }
